#include <stdio.h>
#include <mpi.h>
#include <string.h>
#include <math.h>

#define TAG 1

int main(int argc, char ** argv) {

    int my_rank, world_size, length, next_rank, prev_rank, value, j;
    char message[256], name[80];
    MPI_Status status;

    MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */

    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &world_size);

    if (my_rank == 0)
    {
       printf("I am node 0, i go first\n");
       for (j=1; j<world_size; j=j+1)
       {
         MPI_Send(&my_rank, 1, MPI_INT, j, TAG, MPI_COMM_WORLD);
       }

    }
    else
    {
      MPI_Recv(&value, 1, MPI_INT, 0, TAG, MPI_COMM_WORLD, &status);
      printf("This is node %d receiving node %d 's command. \n", my_rank, value);
    }
    MPI_Finalize();
}
